<?php
/*
Plugin Name: dashborad_view_multisite
Description:ダッシュボードにマルチサイトの情報を表示するプラグインです。
Version: 0.31
Author: Y.ikeda
Author URI: http://55w.jp
*/

/****************************更新履歴*********************************************
2010/01/23	Ver0.31	nav_menu_itemを除外タイプに追加
2010/01/17	Ver0.3	スタイルシートの採用。Custom Post Type UIを使用時以外も
					カスタム投稿を表示(ただしposttypeのみ。Label不可)
2010/01/16	Ver0.2	Custom Post Type UI使用時、カスタム投稿も表示するように変更
2010/01/14	Ver0.1	とりあえず作成
*********************************************************************************/

// ダッシュボードにマルチサイト情報を出力

//スタイルシートの読み込み
add_action('admin_enqueue_scripts', 'dashborad_multisite_css_admin');
 
function dashborad_multisite_css_admin($hook_suffix){
  $post_pages = array('index.php');
  if(in_array($hook_suffix, $post_pages)){
    wp_enqueue_style('dashboard_multi_css', plugins_url('dash_multisite/dashboard_multi.css'), false, '1.0', 'all');
  }
}
//表示部分
function dashboard_multisite_widget_function() {
global $wpdb;
if ( !is_multisite() ){echo 'このサイトはマルチサイトではありません';return;}
if ( ! current_user_can('read') ){echo 'サイトを表示する権限がありません';return;}	

	echo '<div id="dash_div">';
		$ids = $wpdb->get_results("SELECT blog_id FROM $wpdb->blogs");
		$user = wp_get_current_user();
		foreach($ids as $id){
			$blog_id = $id->blog_id;
			$blogs = get_blog_details($blog_id);
			$dashboard = $blogs->siteurl . "/wp-admin/";
			$blogusers = get_users_of_blog($blog_id);
			$blog_user_check =0;
			foreach($blogusers as $key => $val){
				if($val->user_login == $user->user_login){$blog_user_check=1;}
			}
			
			if($blog_user_check){
				echo "<div class='multi_site_div'>";
				echo "<h4>{$blogs->blogname}</h4>";
				echo "<p><a href='{$blogs->siteurl}'>表示</a><span class='dash_bar'>|</span>";
				echo "<a href='$dashboard'>ダッシュボード</a>";
				switch_to_blog($blog_id);
						global $wpdb;		
						$num_posts = wp_count_posts( 'post' );
						$num = number_format_i18n( $num_posts->publish );
						$text = "<span class='dash_bar'>|</span>投稿($num)";
						if ( current_user_can( 'edit_posts' ) ) {$text = "<a href='{$dashboard}edit.php'>{$text}</a>";}
						echo $text;
	
						$num_pages = wp_count_posts( 'page' );
						$num = number_format_i18n( $num_pages->publish );	
						$text = "<span class='dash_bar'>|</span>ページ($num)";
						if ( current_user_can( 'edit_pages' ) ) {$text = "<a href='{$dashboard}edit.php?post_type=page'>{$text}</a>";}
						echo $text;
						
						//Custom Post Type UIを使用しているときのみカスタム投稿を表示
						$cpt_post_types = get_option('cpt_custom_post_types');
						if($cpt_post_types){
							foreach($cpt_post_types as $post_type){
								$num_cpost = wp_count_posts($post_type['name']);
								$num  = number_format_i18n( $num_cpost->publish );
								$text = "<span class='dash_bar'>|</span>{$post_type['label']}({$num})";
								if ( current_user_can( 'edit_posts' ) ) {$text = "<a href='{$dashboard}edit.php?post_type={$post_type['name']}'>{$text}</a>";}
								echo $text;
							}
						}else{
						
						//カスタム投稿も出力。現在調整中
						$sql  = "SELECT post_type FROM $wpdb->posts GROUP BY post_type ";
						$sql .= "HAVING post_type != 'page' AND post_type != 'post' AND post_type != 'revision' AND post_type != 'attachment' AND post_type != 'nav_menu_item'";
						$posttype_names = $wpdb->get_results($sql);
						foreach($posttype_names as $value)
							{
								$num_cpost = wp_count_posts($value->post_type);
								$num  = number_format_i18n( $num_cpost->publish );
								$text = "<span class='dash_bar'>|</span>{$value->post_type}({$num})";
								if ( current_user_can( 'edit_posts' ) ) {$text = "<a href='{$dashboard}edit.php?post_type={$value->post_type}'>{$text}</a>";}
								echo $text;
							}
						
						}
				restore_current_blog();
										
				echo "</p></div>";
			}
		}
	echo "</div>";
} 

// アクションフックで使用する関数を作成する

function add_multi_dush_widgets() {
	wp_add_dashboard_widget('dashboard_multisite', 'マルチサイト', 'dashboard_multisite_widget_function');	
} 

// 'wp_dashboard_setup' アクションにフックし、登録する

add_action('wp_dashboard_setup', 'add_multi_dush_widgets' );

?>